//
//  TodoItem.swift
//  Reminderz
//
//  Created by Cory Bohon on 4/16/18.
//  Copyright © 2018 MartianCraft. All rights reserved.
//

import Cocoa

class TodoItem: NSObject, NSCoding {

    var todoName: String = ""
    var todoDueDate: Date = Date()
    
    init(name: String, dueDate: Date) {
        todoName = name
        todoDueDate = dueDate
    }
    
    required init?(coder aDecoder: NSCoder) {
        todoName = aDecoder.decodeObject(forKey: "todoName") as! String
        todoDueDate = aDecoder.decodeObject(forKey: "todoDueDate") as! Date
    }
    
    func encode(with aCoder: NSCoder) {
        aCoder.encode(todoName, forKey: "todoName")
        aCoder.encode(todoDueDate, forKey: "todoDueDate")
    }
    
    override func isEqual(_ object: Any?) -> Bool {
        var objectsAreSame: Bool = false
        
        if let secondTodo: TodoItem = object as? TodoItem {
            if secondTodo.todoDueDate == todoDueDate &&
                secondTodo.todoName == todoName {
                objectsAreSame = true
            }
        }
        
        return objectsAreSame
    }
}
